C######################################################################
C  File:DMObefNMOcurves.fs
C  Author: Mihai Popovici Jan 94, May 95
C
C       from par: integer nt=1000,nc=10
C       from par: real h=1000.,v=2000.,th=1.
C	from par: real dt=0.01
C
C DMO before NMO (Gardner) curves and Wiggle plot
C
C
C######## ######### ######### ######### ######### ######### ######### ##
c%
        integer nt,ny,ntp,ntheta
	real    t0,y0,zdiff,ydiff
	real    vel,dt,dy

        from par: integer nt=512,ny=256,ntheta=200
        from par: real t0=0.,y0=0.
	from par: real vel=2000.,h=250.
	from par: real dt=0.004,dy=10.
	from par: real ydiff=1280,zdiff=500.
	
	ntp=nt+125-1
	allocate: complex dmo(ntheta,ny)
	allocate: real ddmo(nt,ny)
	allocate: real data2(ntp)
	allocate: complex cozo(ny,2)

        subroutine dmodip(t0,dt,nt,y0,dy,ny,dmo,ddmo,vel,
data2,ntp,h,zdiff,ydiff,ntheta,cozo)

        integer nt,ny,ntp,ntheta
	complex dmo(ntheta,ny)
	complex cozo(ny,2)
	real    ddmo(nt,ny)
	real    data2(ntp)
        real    t0,y0,dt,dy
	real    vel,h,ydiff,zdiff


	integer it,ix,iy,esize,i,iw,np,itd
        real    halfw(63),wavelet(125)
	real    y,t0,h,t
	real    PI,PI2
	real    theta,dtheta,tzero,hv2
	real    y,t,ysrc,yrec,tsrc,trec,xdmo,tdmo,den

        data halfw  /
     &	1.764345E-03,2.576722E-03,3.047558E-03,3.016921E-03,
     &	2.605916E-03,2.196657E-03,2.242794E-03,2.998808E-03,
     &  4.323286E-03,5.692076E-03,6.44902E-03,6.179813E-03,
     &	5.000003E-03,3.568002E-03,2.772822E-03,3.235586E-03,
     &   4.89769E-03,6.954442E-03,8.223221E-03,7.787722E-03,
     &	5.573235E-03,2.503356E-03,9.012813E-05,-3.753605E-04,
     &	1.392875E-03,4.379421E-03,6.694086E-03,6.562323E-03,
     &	3.371305E-03,-1.829862E-03,-6.732948E-03,-8.951747E-03,
     &	-7.391328E-03,-3.036263E-03,1.365858E-03,2.676171E-03,
     &	-8.730142E-04,-8.488163E-03,-1.695114E-02,-2.216093E-02,
     &	-2.137438E-02,-1.495089E-02,-6.548199E-03,-1.462817E-03,
     &   -3.818497E-03,-1.404144E-02,-2.808234E-02,-3.905739E-02,
     &	-4.072597E-02,-3.113304E-02,-1.443052E-02,3.910369E-04,
     &   3.644562E-03,-9.801234E-03,-3.673495E-02,-6.543839E-02,
     &	-7.974487E-02,-6.590544E-02,-1.933651E-02,5.190222E-02,
     &	.1287919,.1878639,.21 /

	do i=1,63
	  wavelet(i)=halfw(i)
	enddo
        do i=1,62
          wavelet(63+i)=wavelet(63-i)
        enddo
        np=125
  
	PI=4.*atan(1.)
	PI2=PI/2.
	dtheta=PI/(ntheta-1)

	esize=8
        call putch('n1','i',ntheta)
        call putch('n2','i',ny)
        call putch('n3','i',1)
        call putch('d1','f',1.)
        call putch('d2','f',1.)
	call putch('esize','i',esize)
        call hclose()

	do iy=1,ny
	  do it=1,nt
	    ddmo(it,iy)=0.
	  enddo
	enddo

        hv2=h*h/(vel*vel)
	do iy=1,ny
	  y=y0+(iy-1)*dy
	  ysrc=y-h 
	  yrec=y+h
	  tsrc=sqrt((ydiff-ysrc)**2+zdiff**2)/vel
	  trec=sqrt((ydiff-yrec)**2+zdiff**2)/vel
	  tzero=2.*sqrt((ydiff-y)**2+zdiff**2)/vel
	  t=tsrc+trec
	  cozo(iy,1)=cmplx(y,t)
	  cozo(iy,2)=cmplx(y,tzero)
	  do it=1,ntheta
            theta=-PI2+(it-1)*dtheta
	    den=sqrt((vel*t)**2-(2.*h*cos(theta))**2)
            xdmo=2*h*h*sin(theta)/den
	    tdmo=sqrt(t*t*(t*t*vel*vel-4.*h*h)+
     &      16.*h*h*hv2*sin(theta)*sin(theta))/den
	    dmo(it,iy)=cmplx(y+xdmo,tdmo)
	    ix=1.5+(y+xdmo)/dy
	    itd=1.5+(tdmo-t0)/dt


	    if(ix.ge.1.and.ix.le.ny.and.itd.le.nt) then
               ddmo(itd,ix)=ddmo(itd,ix)+1.
	    endif
	  enddo
	enddo

	call srite('out',dmo,ntheta*ny*esize)

        call auxputch('n1','i',ny,'cozo')
        call auxputch('n2','i',2,'cozo')
        call auxputch('n3','i',1,'cozo')
        call auxputch('d1','f',1.,'cozo')
        call auxputch('d2','f',1.,'cozo')
        call auxputch('d3','f',1.,'cozo')
        call auxputch('esize','i',esize,'cozo')
	call srite('cozo',cozo,2*ny*esize)

C Convolve the data with the wavelet
        do iy=1,ny
            do it=1,ntp
              data2(it)=0.
            enddo
            do it=1,nt
              do iw=1,np
                data2(it+iw-1)=data2(it+iw-1)+ddmo(it,iy)*
     &          wavelet(iw)
              enddo
            enddo
            do it=1,nt
              ddmo(it,iy)=data2(it+62)
            enddo
        enddo

	esize=4
        call auxputch('n1','i',nt,'dmow')
        call auxputch('n2','i',ny,'dmow')
        call auxputch('n3','i',1,'dmow')
        call auxputch('d1','f',dt,'dmow')
        call auxputch('d2','f',dy,'dmow')
        call auxputch('d3','f',1.,'dmow')
        call auxputch('esize','i',esize,'dmow')

	call srite('dmow',ddmo,nt*ny*esize)


	return
	end



