C######## ######### ######### ######### ######### ######### ######### ##
C  
C
C  File:Gaz2Dphase.fs
C  Author: Mihai Popovici Aug 93
C  Linear phase for DSR 
C
c        from par:     integer nt=64,ny=64
c	 from par:     integer nh=64,nz=64
c	 from par:     integer np=10
c        from par:     real dt=0.01,dy=10
c        from par:     real dh=5,   dz=10
c	 from par:     real h=100
C
C######## ######### ######### ######### ######### ######### ######### ##
c%
        integer nt,nh,ny,nz,ts,ys

        from par:     integer nt=64,ny=64
	from par:     integer nh=64,nz=64
	from par:     integer ys=8,ts=8

	allocate: real    v(nz)
	allocate: real    pdata(nh,nz),tdata(nh,nt,ny)
	allocate: complex ph(nh,nz)

        subroutine DSRphase(nt,nh,ny,nz,v,pdata,tdata,ph,h,ys,ts)
        integer nt,ny,nh,nz,ys,ts
	real    pdata(nh,nz),tdata(nh,nt,ny),v(nz)
	complex ph(nh,nz)

	integer iz,iw,iky,ikh,nw,nky,nkh,esize
        real    dt,dy,dh,dz,h
	real    dw,dky,dkh,w0,ky0,kh0
	real    vv,w,wa,ww2,ky,kya,kh,kha
	real    PI,J
	real    signum,sigw

        from par:     real dt=0.01,dy=10
        from par:     real dh=5,   dz=10
	from par:     real h=100

	esize=4
        call putch('n1','i',nh)
        call putch('n2','i',nz)
        call putch('n3','i',nt/ts*ny/ys)
        call putch('d1','f',dt)
        call putch('d2','f',dy)
        call putch('d3','f',1)
	call putch('esize','i',4)
        call hclose()

	call auxputch('n1','i',nh,'fft')
	call auxputch('n2','i',nz,'fft')
	call auxputch('n3','i',1,'fft')

        PI  =4.*atan(1.)
        nw  =nt
	nky =ny
	nkh =nh
        dw  =2.*PI/(nt*dt)
        dky =2.*PI/(ny*dy)
        dkh =2.*PI/(nh*dh)
	w0  = -PI/dt
	ky0 = -PI/dy
	kh0 = -PI/dh

	do iz=1,nz
	  v(iz)=2000.
	enddo
c	call sreed('vel',v,nz*esize)

C######## ######### ######### ######### ######### ######### ######### ##
        do iky=1,nky
	  do iw=1,nw
	    do ikh=1,nkh
c              kh=kh0+(ikh-1)*dkh
c	      tdata(ikh,iw,iky)=-kh*h
	      tdata(ikh,iw,iky)=0.
	    enddo
	  enddo
	enddo

        do iky=1,nky
	  ky=(ky0+(iky-1)*dky)*0.5
	  kya=abs(ky)
	  do iw=1,nw
	    w=w0+(iw-1)*dw
	    sigw=signum(w)
C######## ######### ######### ######### ######### ######### ######### ##
C stationary phase 
	    do iz=1,nz
	      vv=v(iz)
	      wa=abs(w)/vv
	      ww2=wa*wa
	      do ikh=1,nkh
	        kh=(kh0+(ikh-1)*dkh)*0.5
	        kha=abs(kh)
	        if(wa.ge.kha+kya) then
	          J=-sigw*(sqrt(ww2-(ky+kh)*(ky+kh))+
     &            sqrt(ww2-(ky-kh)*(ky-kh)))*dz
	          tdata(ikh,iw,iky)=tdata(ikh,iw,iky)+J
	          pdata(ikh,iz)=tdata(ikh,iw,iky)
	        else
	          pdata(ikh,iz)=0.
	        endif
	      enddo
	    enddo
	    if(mod(iw,ts).eq.0.and.mod(iky,ys).eq.0) then
              call srite('out',pdata,nh*nz*esize)
	      do iz=1,nz
	        do ikh=1,nkh
	          ph(ikh,iz)=cexp(cmplx(0.,pdata(ikh,iz)))
	        enddo
	      enddo
	      call ft1axis(0,-1.,nh,nz,ph)
	      do iz=1,nz
	        do ikh=1,nkh
	          pdata(ikh,iz)=real(ph(ikh,iz))
	        enddo
	      enddo	          
              call srite('fft',pdata,nh*nz*esize)
			
	    endif
	  enddo
	enddo

C######## ######### ######### ######### ######### ######### ######### ##
	return
	end



