C######## ######### ######### ######### ######### ######### ######### ##
C  <COdata(nt,ny) DSRstpvarcm  v= >ZOdata.H
C
C  File:DSRstpdrv.fs
C  Author: Mihai Popovici July 93, Aug 94
C
C        from history: integer n1:nt,n2:ny
C        from history: real d1:dt,d2:dy
C	 from par:     integer nh=64, nz=64
C        from par:     real dh=5, dz=10
C	 from par:     real h=10
C	 from par:     integer adj=0
C	
C
C  if(adj == 0) then (MODELING)
C    Input   Zero-Offset data
C    Output  Constant-Offset data (single offset)
C  else              (MIGRATION)
C    Input   Constant-Offset data (single offset)
C    Output  Zero-Offset data
C 
C source=/homes/sep/mihai/dev/DSR/DSRstpdrv.fs
C
C######## ######### ######### ######### ######### ######### ######### ##
c%
        integer nt,nh,ny,nz,n3,VelType,adj
	real    dt,dy,dh,h,dz,d3

	from par:	integer adj=1
	if(adj.eq.0) then
	  from history: integer n1:nz
	  from history: integer n2:ny
	  from history: real    d1:dz,d2:dy
	  from par:     integer nt=64
	  from par:     real    dt=0.01
        else
    	  from history:	integer n1:nt
	  from history:	integer n2:ny
	  from history:	real    d1:dt,d2:dy
	  from par:     integer nz=64
	  from par:     real    dz=10.
	endif
        from history: integer n3
        from history: real    d3
	from par:     integer nh=128
	from par:     real    dh=5,h=0.
	from par:     integer Veltype=0

	allocate: real    v(nz)

        subroutine Gpre(adj,dt,nt,dh,nh,dy,ny,dz,nz,h,v,n3,d3,VelType)
        integer adj,nt,ny,nh,nz,n3,VelType
        real    dt,dy,dh,h,dz,d3
	real    v(nz)

	integer esize,iz
	call cmf_init()
	esize=4

	if(adj.eq.0) then
          call putch('n1','i',nt)
          call putch('n2','i',ny)
          call putch('n3','i',n3)
          call putch('d1','f',dt)
          call putch('d2','f',dy)
          call putch('d3','f',1.)
	else
          call putch('n1','i',nz)
          call putch('n2','i',ny)
          call putch('n3','i',n3)
          call putch('d1','f',dz)
          call putch('d2','f',dy)
          call putch('d3','f',1.)
	endif
	call putch('esize','i',esize)
        call hclose()

        call auxputch('n1','i',nz,'mod')
        call auxputch('n2','i',ny,'mod')
        call auxputch('n3','i',1, 'mod')
        call auxputch('d1','f',dz,'mod')
        call auxputch('d2','f',dy,'mod')
        call auxputch('esize','i',esize,'mod')

	call sreed('vel',v,nz*esize)
	if(VelType.eq.1) then
          do iz=1,nz
	    if(v(iz).eq.0) then
	      write(0,*) 'Slowness value of zero, ABORT'
	      stop
	    else
	      v(iz)=1./v(iz)
	    endif
	  enddo
	endif

        call Gprecm(adj,dt,nt,dh,nh,dy,ny,dz,nz,h,v,n3,d3)
	return
	end







